//
//  control.m
//  csv2dx23_09a
//
//  Created by ivan on 14/07/26.
//  Copyright 2014 __MyCompanyName__. All rights reserved.
//

#import "control.h"

@implementation control

- (IBAction)loadCSV:(id)sender {
	NSOpenPanel* lpanel = [NSOpenPanel openPanel];
	[lpanel runModalForTypes:[NSArray arrayWithObjects:@"csv", nil]];

	NSString* csv = [NSString stringWithContentsOfFile:[lpanel filename]
											  encoding:NSASCIIStringEncoding error:NULL];
	NSArray* lines = [csv componentsSeparatedByString:@"\r"];
	if([lines count] < 2)	lines = [csv componentsSeparatedByString:@"\n"];
	int	l = [lines count];
	if(3 < l)	[method setHidden:NO];
	else		[method setHidden:YES];
	if(1 < l){
		[fnCSV setStringValue:[lpanel filename]];
		int	i = 0;
		NSRange	r = [[lines objectAtIndex:i] rangeOfString:@","];
		while(r.location == NSNotFound){
			i++;
			l--;
			r = [[lines objectAtIndex:i] rangeOfString:@","];
		}
		NSMutableString* str;
		str = [[NSMutableString alloc] initWithString:[lines objectAtIndex:i]];
		for(i += 1; i < [lines count]; i++){
			r = [[lines objectAtIndex:i] rangeOfString:@","];
			if(r.location == NSNotFound){
				l--;
			}else{
				if(![str hasSuffix:@"\n"] && ![[lines objectAtIndex:i] hasPrefix:@"\n"])
					[str appendString:@"\n"];
				[str appendString:[lines objectAtIndex:i]];
			}
		}
		[dat release];
		dat = str;
		[graph setDat:dat];
		[graph setNeedsDisplay:YES];
		[self setNeedsDisplay:YES];
		NSRect	dirtyRect;
		[graph drawRect:dirtyRect];
	}
}

- (IBAction)saveDXF:(id)sender {
	int		i, j;
	NSMutableString* dxf = [[NSMutableString alloc]
							initWithString:@"  0\nSECTION\n  2\nENTITIES\n"];
	NSArray* l = [dat componentsSeparatedByString:@"\n"];
	if(2 < [l count]){											// 3D
		if([[method selectedCell] tag] == 1){					// line
			NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
			NSArray* sy;
			for(i < 1; i < [l count]; i++){
				sy = [[l objectAtIndex:i] componentsSeparatedByString:@","];
				[dxf appendString:@"  0\nPOLYLINE\n  8\ncsv2dx23\n 66\n1\n 70\n8\n"];
				for(j = 1; j < [sy count]; j++){
					[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n"
					 , [[sx objectAtIndex:j] floatValue]
					 , [[sy objectAtIndex:0] floatValue]
					 , [[sy objectAtIndex:j] floatValue]];
				}
				[dxf appendString:@"  0\nSEQEND\n"];
			}
			for(j = 1; j < [sx count]; j++){
				[dxf appendString:@"  0\nPOLYLINE\n  8\ncsv2dx23\n 66\n1\n 70\n8\n"];
				for(i = 1; i < [l count]; i++){
					sy = [[l objectAtIndex:i] componentsSeparatedByString:@","];
					[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n"
					 , [[sx objectAtIndex:j] floatValue]
					 , [[sy objectAtIndex:0] floatValue]
					 , [[sy objectAtIndex:j] floatValue]];
				}
				[dxf appendString:@"  0\nSEQEND\n"];
			}
		}else if([[method selectedCell] tag] == 2){				// polygon
			NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
			NSArray* sy;
			NSArray* sz;
			for(i = 2; i < [l count]; i++){
				sy = [[l objectAtIndex:i-1] componentsSeparatedByString:@","];
				sz = [[l objectAtIndex:i] componentsSeparatedByString:@","];
				for(j = 2; j < [sx count]; j++){
					[dxf appendString:@"  0\nPOLYLINE\n  8\ncsv2dx23\n 66\n1\n 70\n9\n"];
					[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j] floatValue]];
					[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j] floatValue]];
					[dxf appendString:@"  0\nSEQEND\n"];
				}
			}
		}else if([[method selectedCell] tag] == 3){				// face
			NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
			NSArray* sy;
			NSArray* sz;
			for(i = 2; i < [l count]; i++){
				sy = [[l objectAtIndex:i-1] componentsSeparatedByString:@","];
				sz = [[l objectAtIndex:i] componentsSeparatedByString:@","];
				for(j = 2; j < [sx count]; j++){
					[dxf appendString:@"  0\n3DFACE\n  8\ncsv2dx23\n"];
					[dxf appendFormat:@" 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@" 11\n%f\n 21\n%f\n 31\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@" 12\n%f\n 22\n%f\n 32\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j] floatValue]];
					[dxf appendFormat:@" 13\n%f\n 23\n%f\n 33\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j] floatValue]];
				}
			}
		}else if([[method selectedCell] tag] == 4){				// triangle
			NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
			NSArray* sy;
			NSArray* sz;
			for(i = 2; i < [l count]; i++){
				sy = [[l objectAtIndex:i-1] componentsSeparatedByString:@","];
				sz = [[l objectAtIndex:i] componentsSeparatedByString:@","];
				for(j = 2; j < [sx count]; j++){
					[dxf appendString:@"  0\n3DFACE\n  8\ncsv2dx23\n"];
					[dxf appendFormat:@" 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@" 11\n%f\n 21\n%f\n 31\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@" 12\n%f\n 22\n%f\n 32\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j] floatValue]];
					[dxf appendFormat:@" 13\n%f\n 23\n%f\n 33\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j] floatValue]];
					[dxf appendString:@"  0\n3DFACE\n  8\ncsv2dx23\n"];
					[dxf appendFormat:@" 10\n%f\n 20\n%f\n 30\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sy objectAtIndex:0] floatValue]
					 ,[[sy objectAtIndex:j] floatValue]];
					[dxf appendFormat:@" 11\n%f\n 21\n%f\n 31\n%f\n"
					 ,[[sx objectAtIndex:j-1] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j-1] floatValue]];
					[dxf appendFormat:@" 12\n%f\n 22\n%f\n 32\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j] floatValue]];
					[dxf appendFormat:@" 13\n%f\n 23\n%f\n 33\n%f\n"
					 ,[[sx objectAtIndex:j] floatValue]
					 ,[[sz objectAtIndex:0] floatValue]
					 ,[[sz objectAtIndex:j] floatValue]];
				}
			}
		}
	}else if(1 < [l count]){									// 2D
		[dxf appendString:@"  0\nPOLYLINE\n  8\ncsv2dx23\n 66\n1\n 70\n0\n"];
		NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
		NSArray* sy = [[l objectAtIndex:1] componentsSeparatedByString:@","];
		for(j = 0; j < [sx count]; j++){
			[dxf appendFormat:@"  0\nVERTEX\n 10\n%f\n 20\n%f\n"
			 , [[sx objectAtIndex:j] floatValue], [[sy objectAtIndex:j] floatValue]];
		}
	}
	[dxf appendString:@"  0\nENDSEC\n  0\nEOF\n"];
	NSSavePanel* spanel = [NSSavePanel savePanel];
	[spanel setRequiredFileType:@"dxf"];
	[spanel runModal];
	if ([dxf writeToFile:[spanel filename] atomically:YES
				encoding:NSASCIIStringEncoding error:NULL]){
		[fnDXF setStringValue:[spanel filename]];
	}else{
		[fnDXF setStringValue:@"error"];
	}
}

@end
