//
//  graph.m
//  csv2dx23_09a
//
//  Created by ivan on 14/07/26.
//  Copyright 2014 __MyCompanyName__. All rights reserved.
//

#import "graph.h"


@implementation graph

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)setDat:(NSString *)str {
	dat = str;
}

- (void)drawRect:(NSRect)dirtyRect {
    // Drawing code here.
	[[NSColor lightGrayColor] set];
	[NSBezierPath strokeRect:dirtyRect];
	[[NSColor blackColor] set];

	if(dat){
		int i, j, c;
		float dx, dy, minx, miny, maxx, maxy, s, x, y;
		NSPoint p;
		NSBezierPath* path = [[NSBezierPath alloc] init];
		[path setLineWidth:1.0];
		NSArray* l = [dat componentsSeparatedByString:@"\n"];
		if(2 < [l count]){										// 3D
			minx = maxx = miny = maxy = 0.;
			NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
			NSArray* sy = [[l objectAtIndex:1] componentsSeparatedByString:@","];
			minx = maxx = 0.866 * ([[sx objectAtIndex:1] floatValue] + [[sy objectAtIndex:0] floatValue]);
			miny = maxy = 0.5 * ([[sx objectAtIndex:1] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:1] floatValue];
			for(j = 2; j < [sy count]; j++){
				x = 0.866 * ([[sx objectAtIndex:j] floatValue] + [[sy objectAtIndex:0] floatValue]);
				y = 0.5 * ([[sx objectAtIndex:j] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:j] floatValue];
				if(minx > x)	minx = x;
				if(maxx < x)	maxx = x;
				if(miny > y)	miny = y;
				if(maxy < y)	maxy = y;
			}
			for(i = 2; i < [l count]; i++){
				sy = [[l objectAtIndex:i] componentsSeparatedByString:@","];
				for(j = 1; j < [sy count]; j++){
					x = 0.866 * ([[sx objectAtIndex:j] floatValue] + [[sy objectAtIndex:0] floatValue]);
					y = 0.5 * ([[sx objectAtIndex:j] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:j] floatValue];
					if(minx > x)	minx = x;
					if(maxx < x)	maxx = x;
					if(miny > y)	miny = y;
					if(maxy < y)	maxy = y;
				}
			}
			dx = maxx - minx;
			dy = maxy - miny;
			if(dy < dx)	s = 180 / dx;
			else		s = 180 / dy;
			for(i = 1; i < [l count]; i++){
				sy = [[l objectAtIndex:i] componentsSeparatedByString:@","];
				p.x = (0.866 * ([[sx objectAtIndex:1] floatValue] + [[sy objectAtIndex:0] floatValue]) - minx) * s + 4;
				p.y = (0.5 * ([[sx objectAtIndex:1] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:1] floatValue] - miny) * s + 4;
				[path moveToPoint:p];
				for(j = 2; j < [sy count]; j++){
					p.x = (0.866 * ([[sx objectAtIndex:j] floatValue] + [[sy objectAtIndex:0] floatValue]) - minx) * s + 4;
					p.y = (0.5 * ([[sx objectAtIndex:j] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:j] floatValue] - miny) * s + 4;
					[path lineToPoint:p];
				}
			}
			for(j = 1; j < [sx count]; j++){
				sy = [[l objectAtIndex:1] componentsSeparatedByString:@","];
				p.x = (0.866 * ([[sx objectAtIndex:j] floatValue] + [[sy objectAtIndex:0] floatValue]) - minx) * s + 4;
				p.y = (0.5 * ([[sx objectAtIndex:j] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:j] floatValue] - miny) * s + 4;
				[path moveToPoint:p];
				for(i = 2; i < [l count]; i++){
					sy = [[l objectAtIndex:i] componentsSeparatedByString:@","];
					p.x = (0.866 * ([[sx objectAtIndex:j] floatValue] + [[sy objectAtIndex:0] floatValue]) - minx) * s + 4;
					p.y = (0.5 * ([[sx objectAtIndex:j] floatValue] - [[sy objectAtIndex:0] floatValue]) + [[sy objectAtIndex:j] floatValue] - miny) * s + 4;
					[path lineToPoint:p];
				}
			}
			[path stroke];
		}else if(1 < [l count]){								// 2D
			NSArray* sx = [[l objectAtIndex:0] componentsSeparatedByString:@","];
			NSArray* sy = [[l objectAtIndex:1] componentsSeparatedByString:@","];
			minx = maxx = [[sx objectAtIndex:0] floatValue];
			miny = maxy = [[sy objectAtIndex:0] floatValue];
			if([sx count] < [sy count])	c = [sx count];
			else						c = [sy count];
			for(i = 1; i < c; i++){
				x = [[sx objectAtIndex:i] floatValue];
				if(minx > x)	minx = x;
				if(maxx < x)	maxx = x;
				y = [[sy objectAtIndex:i] floatValue];
				if(miny > y)	miny = y;
				if(maxy < y)	maxy = y;
			}
			dx = maxx - minx;
			dy = maxy - miny;
			if(dy < dx)	s = 180 / dx;
			else		s = 180 / dy;
			p.x = ([[sx objectAtIndex:0] floatValue] - minx) * s + 4;
			p.y = ([[sy objectAtIndex:0] floatValue] - miny) * s + 4;
			[path moveToPoint:p];
			for(i = 1; i < c; i++){
				p.x = ([[sx objectAtIndex:i] floatValue] - minx) * s + 4;
				p.y = ([[sy objectAtIndex:i] floatValue] - miny) * s + 4;
				[path lineToPoint:p];
			}
			[path stroke];
		}
	}
}

@end
